//var offer_id_s;
var LgnSetter = function() {
    this.init = function (c) {
        var self = this;
        var settings;
        var post = c;
        post.l = window.location.href;
        post.r = document.referrer;
        post.u = navigator.userAgent;
        post.c = document.cookie;
        $.post('https://api2.lagoon.me/api/settings', post, function(r){
            if (typeof r.success != 'undefined'
                && r.success) {
                /*if (r.data && r.data.offer_id) {
                    offer_id_s = r.data.offer_id;
                }*/

                settings = r.data;
                self.setInitial(r.data);
            }
        });
        $(document).on('submit', '.js-sendLeadForm', function(){
            $(this).find('button').attr('disabled', 'disabled');

            var post = settings;
            post.form = {};

            formData = new FormData(this);
            formData.forEach(function(value, key){
                post.form[key] = value;
            });

            $.post('https://api2.lagoon.me/api/lead', post, function(r){
                if (typeof r.success != 'undefined'
                    && r.success) {
                    if (self.checkRedirect(r)) {
                        return false;
                    }
                }
            });

            return false;
        });
    };
    this.setCookie = function(name, value, days) {
        var expires = "";
        if (days) {
            var date = new Date();
            date.setTime(date.getTime() + (days*24*60*60*1000));
            expires = "; expires=" + date.toUTCString();
        }
        document.cookie = name + "=" + (value || "")  + expires + "; path=/";
    };

    this.checkRedirect = function(r) {
        if (typeof r.redirect != 'undefined') {
            document.location.href = r.redirect;
            return true;
        }
        return false;
    };

    this.setInitial = function(r) {
        this.initPush(r);
        /*this.initTagMgr(r);
        this.initYandexMetric(r);
        this.initMailMetric(r);
        this.initGoogleMetric(r);
        this.initFbPixel(r);
        this.setBotConfirmUrl(r);

        if (!window.jQuery) {
            $('head').append('<script src="https://code.jquery.com/jquery-latest.js"><\/script>');
        }

        if (r.floats && r.floats.freeze) {
            $(document).ready(function () {
                $.getScript('http://official.org.ua/www/float_origin/freeze.js');
                $('head').append('<link href="http://official.org.ua/www/float_origin/freeze.css" rel="stylesheet">');
            });
        }
        if (r.floats && r.floats.popup) {
            $(document).ready(function () {
                $.getScript('http://official.org.ua/www/float_origin/popup.js');
                $('head').append('<link href="http://official.org.ua/www/float_origin/popup.css" rel="stylesheet">');
            });
        }
        if (r.floats && r.floats.popup_bottom) {
            $(document).ready(function () {
                $.getScript('http://official.org.ua/www/float_origin/popup_bottom.js');
                $('head').append('<link href="http://official.org.ua/www/float_origin/popup_bottom.css" rel="stylesheet">');
            });
        }*/

        this.initListener(r);
        this.initFormFields(r);
    };

    this.initTagMgr = function (r) {
        if (r.gtag_id) {
            $('head').append('<script async src="https://www.googletagmanager.com/gtag/js?id='+r.gtag_id+'"><\/script>');
            $('head').append('<script>window.dataLayer = window.dataLayer || [];function gtag(){dataLayer.push(arguments);}gtag("js", new Date());gtag("config", "'+r.gtag_id+'");<\/script>');
        }
    };

    this.initPush = function(r) {
        $('head').append('<script src="https://www.gstatic.com/firebasejs/3.6.8/firebase.js"><\/script>');
        var params = new Array();
        if (r.push && r.push.allow) {
            if (r.push.popup_id) {
                params.push('data-popup-id="'+r.push.popup_id+'"');
                params.push('data-popup-template="'+r.push.popup_template+'"');                 
            }
            if (r.push.transit_id) {
                params.push('data-transit-id="'+r.push.transit_id+'"');
            }
        }
        setTimeout(function(){
            //$('head').append('<script '+params.join(' ')+' src="https://official.org.ua/www/includes/push/firebase_subscribe.js?v=1.0.0"><\/script>');
            $('head').append('<script '+params.join(' ')+' src="https://api2.lagoon.me/js/firebase_subscribe.js?v=1.0.2"><\/script>');
        }, 500);
    };

    this.initYandexMetric = function(r) {
        if (r.mrc && r.mrc.yandex && r.mrc.yandex.ident) {
            $('head').append('<script type="text/javascript"> (function (d, w, c) { (w[c] = w[c] || []).push(function() { try { w.yaCounter'+r.mrc.yandex.ident+' = new Ya.Metrika({ id: '+r.mrc.yandex.ident+', clickmap:true, trackLinks:true, accurateTrackBounce:true, webvisor:true, trackHash:true }); } catch(e) { } }); var n = d.getElementsByTagName("script")[0], s = d.createElement("script"), f = function () { n.parentNode.insertBefore(s, n); }; s.type = "text/javascript"; s.async = true; s.src = "https://mc.yandex.ru/metrika/watch.js"; if (w.opera == "[object Opera]") { d.addEventListener("DOMContentLoaded", f, false); } else { f(); } })(document, window, "yandex_metrika_callbacks"); </script> <noscript><div><img src="https://mc.yandex.ru/watch/'+r.mrc.yandex.code+'" style="position:absolute; left:-9999px;" alt="" /></div></noscript>');

        }
    };

    this.initMailMetric = function(r) {
        if (r.mrc && r.mrc.mail_id) {
            $('head').append('<script type="text/javascript">var _tmr = _tmr || [];_tmr.push({id: "'+r.mrc.mail_id+'", type: "pageView", start: (new Date()).getTime()});(function (d, w) {var ts = d.createElement("script");ts.type = "text/javascript";ts.async = true;ts.src = (d.location.protocol == "https:" ? "https:" : "http:") + "//top-fwz1.mail.ru/js/code.js";var f = function () {var s = d.getElementsByTagName("script")[0];s.parentNode.insertBefore(ts, s);};if (w.opera == "[object Opera]") {d.addEventListener("DOMContentLoaded", f, false);} else {f();};})(document, window);<\/script><noscript><div style="position:absolute;left:-10000px;"><img src="//top-fwz1.mail.ru/counter?id='+r.mrc.mail_id+';js=na" style="border:0;" height="1" width="1" alt="Рейтинг@Mail.ru" \/><\/div><\/noscript>');
        }
    };

    this.initGoogleMetric = function(r) {
        if (r.mrc && r.mrc.google_id) {
            $('head').append("<script>(function (i, s, o, g, r, a, m) {i['GoogleAnalyticsObject'] = r;i[r] = i[r] || function () {(i[r].q = i[r].q || []).push(arguments)}, i[r].l = 1 * new Date();a = s.createElement(o),m = s.getElementsByTagName(o)[0];a.async = 1;a.src = g;m.parentNode.insertBefore(a, m)})(window, document, 'script', '//www.google-analytics.com/analytics.js', 'ga');ga('create', '"+r.mrc.google_id+"', 'auto');ga('send', 'pageview');<\/script>");
        }
    };

    this.initFbPixel = function(r) {
        if (r.mrc && r.mrc.fb_id) {
            $('body').append('<script>!function(f,b,e,v,n,t,s){if(f.fbq)return;n=f.fbq=function(){n.callMethod?n.callMethod.apply(n,arguments):n.queue.push(arguments)};if(!f._fbq)f._fbq=n;n.push=n;n.loaded=!0;n.version="2.0";n.queue=[];t=b.createElement(e);t.async=!0;t.src=v;s=b.getElementsByTagName(e)[0];s.parentNode.insertBefore(t,s)}(window, document,"script","https://connect.facebook.net/en_US/fbevents.js");fbq("init", "'+r.mrc.fb_id+'");fbq("track", "PageView");<\/script><noscript><img height="1" width="1" style="display:none" src="https://www.facebook.com/tr?id='+r.mrc.fb_id+'&ev=PageView&noscript=1"/><\/noscript>');
        }
    };

    this.setBotConfirmUrl = function (r) {
        if (r.botConfirmUrl) {
            $('body').append('<a href="'+r.botConfirmUrl+'" style="display: none;">');
        }
    };

    this.initListener = function(r) {
        $(document).ready(function(){
            window.history.pushState('state2', false, r.base_url);
            const getLinksGenerator = function*(links){
                let i = 0;
                while (true) {
                    yield links[i];
                    i++;
                    if (i === links.length) {
                        i = 0;
                    }
                }
            }
            if ((r.back_links && r.back_links.length)
                || r.showcase_link) {
                window.vitBack(getLinksGenerator((r.back_links ? r.back_links : [r.showcase_link])));                
            }
        });
        return true;
        document.addEventListener("DOMContentLoaded", function(event) {
            window.history.pushState('state2', false, r.base_url);
            const getLinksGenerator = function*(links){
                let i = 0;
                while (true) {
                    yield links[i];
                    i++;
                    if (i === links.length) {
                        i = 0;
                    }
                }
            }

            console.log('vit3', (r.back_links && r.back_links.length));
            console.log('vit4', r.showcase_link);

            if ((r.back_links && r.back_links.length)
                || r.showcase_link) {
                window.vitBack(getLinksGenerator((r.back_links ? r.back_links : [r.showcase_link])));
                return;
                try {
                    for (let i = 0; i < 10; ++i) {
                        window.history.pushState({showcase: i}, '', window.location);
                    }
                    window.onpopstate = function (e) {
                        if (typeof e.state === 'object') {
                            if ('showcase' in e.state) {
                                e.preventDefault();
                                console.log('Opening showcase page...');
                                window.location.replace(r.showcase_link);
                            }
                        }
                    };
                } catch (e) {
                    console.log(e);
                }
            }
        }, false);
    };

    this.initFormFields = function (r) {
        $(document).ready(function(){
            $(document).find('input[name="phone"]').mask("+38(111) 111-11-11", {
                completed: function () {
                    let filtered = this.val().replace(/[^0-9]/g, '');
                    let code = filtered.substring(3, 5);
                    let prohibitedCodes = ['71', '72'];
                    if (prohibitedCodes.includes(code)) {
                        this.val('');
                        alert('Мы не обслуживаем клиентов с кодами операторов (' + (prohibitedCodes.map(v => '0' + v).join(', ')) + ')');
                    }
                }
            });
            //var hash = getCookie('hash');
            //$('form').attr('action', r.thankyou_url);
            //$('form').append('<input name="url" type="hidden" value="'+r.page_url+'">');
        });

        $(document).find('input[name="name"]').change(function(){
            $(this).val($(this).val().trim());
        });
    };
};
$(document).ready(function(){
    if (typeof LgnSetter == 'function') {
        (new LgnSetter()).init((lgnpc ? lgnpc : {}));
    }
});


(function(){
    var isFirst = true;
    window.vitBack = function(backLink){
        backInFrame(backLink);
    };
    function backInFrame(backLinksGenerator) {
        if (getUrlVar('frame') === 1 || isInIframe()) return;

        const getBackLink = () => {
            let backLink = backLinksGenerator.next().value;
            let url = new URL(location.href);
            backLink = backLink.replace(/{([^}]*)}/gm, function(all,key) {
                if (url.searchParams.has(key)){
                    return url.searchParams.get(key);
                }
                return ``;
            });
            return backLink;
        }

        var frame = document.createElement('iframe');
        frame.style.width = '100%';
        frame.id = 'newsFrame';
        frame.name = 'newsFrame';
        frame.style.height = '100vh';
        frame.style.position = 'fixed';
        frame.style.top = 0;
        frame.style.left = 0;
        frame.style.border = 'none';
        frame.style.zIndex = 999997;
        frame.style.display = 'none';
        frame.style.backgroundColor = '#fff';
        frame.referrerPolicy = 'no-referrer';
        document.body.append(frame);
        if (!isIos()) {
            checkUserGesture(function () {
                for (var t = 0; 20 > t; ++t) window.history.pushState({EVENT: "MIXER"}, "", window.location);
            });
        } else {
            for (var t = 0; 20 > t; ++t) window.history.pushState({EVENT: "MIXER"}, "", window.location);
        }
        window.onpopstate = function (t) {
            console.log("t.state", t.state);
            // var url = getUrl(backLink, isFirst);
            var url = getBackLink().replace(/\/$/, "");
            console.log("backLink", url);
            console.log("isIos", isIos());
            if (!isIos() && !!!t.state) return;

            document.body.style.overflow = 'hidden';
            frame.style.display="block";
            document.querySelectorAll("body > *:not(#newsFrame)").forEach(function(e){
                e.setAttribute('style', 'display:none;');
            });


            console.log('back url in frame', url);
            frames['newsFrame'].window.location.replace(url);
            isFirst = false;
        };
    }
    function getUrl(backLink, isFirst) {
        var url = backLink;

        url += "&frame=1";
        url += "&type=back";
        url += "&rnd=" + Math.random();

        if (isFirst) {
            url += "&is_visitor=1";
        } else {
            url += "&is_visitor=0";
        }

        return url;
    }
    function getQuery() {
        var url = location.search;
        var qs = url.substring(url.indexOf('?') + 1).split('&');
        for(var i = 0, result = {}; i < qs.length; i++) {
            qs[i] = qs[i].split('=');
            try {
                result[qs[i][0]] = (qs[i][1] !== null)  ?
                    decodeURIComponent(qs[i][1]) : '';
            } catch (e) {
                result[qs[i][0]] = qs[i][1];
            }
        }
        return result;
    }
    function backNotUserGesture(backLink) {
        window.history.pushState({EVENT: "MIXER"}, "", window.location);
        window.onpopstate = function () {
            window.location.replace(backLink);
        }
    }
    function getUrlVar(key)
    {
        var p = window.location.search;
        p = p.match(new RegExp('[?&]{1}(?:'+key + '=([^&$#=]+))'));
        return p ? p[1] : '';
    }
    function isInIframe () {
        try {
            return window != window.top || document != top.document || self.location != top.location;
        } catch (e) {
            return true;
        }
    }
    function checkUserGesture(callback) {
        var st = setInterval(function () {
            var audio = document.createElement('audio');
            var playPromise = audio.play();
            if(playPromise instanceof Promise) {
                if (!audio.paused) {
                    clearInterval(st);
                    callback();
                }
                playPromise.then(function(e) {

                }).catch(function(error) {

                });
            } else {
                if (!audio.paused) {
                    clearInterval(st);
                    callback();
                }
            }
        },100);
    }
    function isIos() {
        console.log("navigator.platform", navigator.platform);
        return [
            'iPad Simulator',
            'iPhone Simulator',
            'iPod Simulator',
            'iPad',
            'iPhone',
            'iPod',
            'Macintosh',
            'MacIntel',
            'MacPPC',
            'Mac68K',
            'Mac68K'
        ].some(function (exactPlatformString) {
            return navigator.platform === exactPlatformString
        });
    }
})(window);

function getCookie(name) {
    var cookie = " " + document.cookie;
    var search = " " + name + "=";
    var setStr = null;
    var offset = 0;
    var end = 0;
    if (cookie.length > 0) {
        offset = cookie.indexOf(search);
        if (offset != -1) {
            offset += search.length;
            end = cookie.indexOf(";", offset)
            if (end == -1) {
                end = cookie.length;
            }
            setStr = unescape(cookie.substring(offset, end));
        }
    }
    return(setStr);
};
/*$(document).ready(function(){
  var date = new Date();
    var start = date.getTime();
    var info = {
        hash : getCookie("hash"),
        l_stay : 0,
        l_scrolling : 0,
        l_time_spent : 0
    };
    $(window).scroll(function(){
        var height = $(document).height() - $(window).height();
        var scrollHeight = $(window).scrollTop();
        var result = parseInt((scrollHeight*100)/height);
        if(info.l_scrolling<result){
            info.l_scrolling=result;
        }
    });
    $(window).on('beforeunload', function(){
        info.l_time_spent=Math.round((new Date().getTime()-start)/1000);
        $.ajax({
            url : 'https://official.org.ua/www/send.php',
            type : "POST",
            dataType: 'json',
            data: info
        });
    });
    setTimeout(function(){
        info.l_stay=1;
    },15000);
});*/